Subject: [PATCH 1/2] arm64: Blacklist non-kprobe-able symbols

From: [email-masked] (Pratyush Anand)
Date: Mon, 6 Jul 2015 16:18:15 +0530

On 06/07/2015:10:03:24 AM, Will Deacon wrote:
> On Mon, Jul 06, 2015 at 06:03:21AM +0100, Pratyush Anand wrote:
> > Add all function symbols which are called from do_debug_exception under
> > NOKPROBE_SYMBOL, as they can not kprobed.
> 
> It's a shame this has to be so manual, but I suppose it's done on a
> best-effort basis to catch broken probe placement.
> 
> If we miss a function and somebody probes it, do we just get stuck in a
> recursive exception, or could we print something suggesting that a symbol
> be annotated as NOKPROBE?

In some cases we land into a recursive reenter_kprobe:

echo "p kfree" > /sys/kernel/debug/tracing/kprobe_events
echo "p single_step_handler" >> /sys/kernel/debug/tracing/kprobe_events
echo 1 >  /sys/kernel/debug/tracing/events/enable

[  116.904194] BUG: failure at
.../arch/arm64/kernel/kprobes.c:288/reenter_kprobe()!

In some other 
echo "p kfree" > /sys/kernel/debug/tracing/kprobe_events
echo "p el0_sync" >> /sys/kernel/debug/tracing/kprobe_events
echo 1 >  /sys/kernel/debug/tracing/events/enable

Infinite loop of:
[  142.731336] Unexpected kernel single-step exception at EL1

In 1st case currently only address is printed.
pr_warn("Unrecoverable kprobe detected at %p.\n", p->addr);
So, while in 1st case we may also print name of symbol, we can not do
much in second case.

Now, I am running some test with all the symbols in /proc/kallsyms and
I noticed that there might be few more symbols which may not allow
kprobing. So, may be I will resend this series with updates.

~Pratyush